; -=- BSMacro Core -=-
Include BSM\Core.mac

; -=- Define Program and Packages -=- (NEEDS TO BE 8086)
DefineProgram 586, 16, Dos, Small, 200h
DefinePackage Disk, Bios, Video, Cmos

StartBlankData
  ; -=- Main Program Data -=-
  Temp8 db ?
  Log_Handle dw ?
  Log_BufferBytes dw ?
  Log_WrittenBytes dw ?
  ; -=- Main Program Data -=-
  ; -=- Cpu Detect -=-
  CpuDet_MaxArgVal dd ?
  CpuDet_TypeVal dd ?
  CpuDet_BrandIDVal dd ?
  CpuDet_Feature dd ?
  CpuDet_Vendor1 dd ?
  CpuDet_Vendor2 dd ?
  CpuDet_Vendor3 dd ?
  CpuDet_ExtMaxArgVal dd ?
  CpuDet_ExtCpuName1 dd ?
  CpuDet_ExtCpuName2 dd ?
  CpuDet_ExtCpuName3 dd ?
  CpuDet_ExtCpuName4 dd ?
  CpuDet_ExtCpuName5 dd ?
  CpuDet_ExtCpuName6 dd ?
  CpuDet_ExtCpuName7 dd ?
  CpuDet_ExtCpuName8 dd ?
  CpuDet_ExtCpuName9 dd ?
  CpuDet_ExtCpuName10 dd ?
  CpuDet_ExtCpuName11 dd ?
  CpuDet_ExtCpuName12 dd ?
  CpuDet_Ext1DFeatureFlags dd ?
  CpuDet_Ext1CFeatureFlags dd ?
  CpuDet_SerialNumber1 dd ?
  ; -=- Cpu Detect -=-
EndBlankData

StartData
 ; -=- Main Program Data -=-
 String_Cr db 13, 10, "$"
 Czs Log_File, "Probe.log", 0
 Cdse Log_Starting, " -=- Starting Probe Log -=-"
 Cdse Log_Finished, " -=- Finished Probe Log -=-"
 ; -=- Main Program Data -=-

 ; -=- Cpu Detect -=-
 ; - Level 0 Scan -
 Cdse CpuDet_Start, " -=- CPU Detection Start -=- "
 Cdse CpuDet_End, " -=- CPU Detection End -=- "
 Cdse CpuDet_80888086, "8088/8086 Detected"
 Cdse CpuDet_V20V30, "V20/V30 Detected"
 Cdse CpuDet_80186, "80186 Detected"
 Cdse CpuDet_80286, "80286 Detected"
 Cdse CpuDet_80386, "80386 Detected"
 Cdse CpuDet_80486, "80486 Detected"
 Cdse CpuDet_IdSupport, "CpuID Supported (586+)"
 ; - Level 0 Scan -

 ; - Level 1 CpuID 0 -
 Crs CpuDet_VendorString, "Cpu Vendor: "
  Cdse CpuDet_Vendor, "            "
 Crs CpuDet_MaxArgString, "Max Arguments: "
  Cdse CpuDet_MaxArg, "             "
 Cie 1, Cpu_Intel, Cpu_AMD
 Crs CpuDet_Intel, "GenuineIntel"
 Crs CpuDet_AMD, "AuthenticAMD"
 ; - Level 1 CpuID 0 -

 ; - Level 2 CpuID 1 -
 ; - Feature (CpuID 1/Edx) -
 Cds CpuDet_Flags, " -=- Cpu Flags -=- "
 Cds CpuDet_Flags_Short, "Cpu Flags: "
 Cdse CpuDet_0, "Floating Point Unit"
 Cds CpuDet_0_Short, "FPU "
 Cdse CpuDet_1, "V86 Mode Extensions"
 Cds CpuDet_1_Short, "VME "
 Cdse CpuDet_2, "Debug Extensions - I/O Breakpoints"
 Cds CpuDet_2_Short, "DE "
 Cdse CpuDet_3, "Page Size Extensions (4mb Pages)"
 Cds CpuDet_3_Short, "PSE "
 Cdse CpuDet_4, "Time Stamp Counter and RDTSC Instruction"
 Cds CpuDet_4_Short, "TSC "
 Cdse CpuDet_5, "Model Specific Registers"
 Cds CpuDet_5_Short, "MSR "
 Cdse CpuDet_6_Intel, "Physical Address Extensions (36bit Address, 2mb Pages)"
 Cds CpuDet_6_Intel_Short, "PAE "
 Cdse CpuDet_6_Cyrix, "Support PTE"
 Cds CpuDet_6__Cryix_Short, "PTE "
 Cdse CpuDet_7, "Machine Check Exception"
 Cds CpuDet_7_Short, "MCE "
 Cdse CpuDet_8, "CmpXchg8B Instruction Present"
 Cds CpuDet_8_Short, "CX8 "
 Cdse CpuDet_9_Intel, "Local APIC On Chip"
 Cds CpuDet_9_Intel_Short, "APIC "
 Cdse CpuDet_9_AMD_K5, "Page Global Extension"
 Cds CpuDet_9_AMD_K5_Short, "PGE "
 ;10 - reserved
 Cdse CpuDet_11, "Fast System Call(Pentium Pro)"
 Cds CpuDet_11_Short, "SEP "
 Cdse CpuDet_12, "Memory Type Range Registers"
 Cds CpuDet_12_Short, "MTRR "
 Cdse CpuDet_13, "Page Global Enable"
 Cds CpuDet_13_Short, "PGE "
 Cdse CpuDet_14, "Machine Check Architecture and Mcg_Cap Register"
 Cds CpuDet_14_Short, "MCA "
 Cdse CpuDet_15, "Conditional Move Instructions"
 Cds CpuDet_15_Short, "CMOV "
 Cdse CpuDet_16, "Page Attribute Table"
 Cds CpuDet_16_Short, "PAT "
 Cdse CpuDet_17, "36bit Page Size Extenions (36bit Addressing for 4mb Pages with 4b Descriptors)"
 Cds CpuDet_17_Short, "PSE36 "
 Cdse CpuDet_18, "Processor Serial Number"
 Cds CpuDet_18_Short, "SN "
 Cdse CpuDet_19, "Cache Flush"
 Cds CpuDet_19_Short, "CFLSH "
 ;20 - reserved
 Cdse CpuDet_21, "Debug Trace Store"
 Cds CpuDet_21_Short, "DTES "
 Cdse CpuDet_22, "ACPI Support"
 Cds CpuDet_22_Short, "ACPI "
 Cdse CpuDet_23, "MultiMedia Extensions"
 Cds CpuDet_23_Short, "MMX "
 Cdse CpuDet_24, "FxSave and FxRstor Instructions"
 Cds CpuDet_24_Short, "FXSR "
 Cdse CpuDet_25, "SSE Instructions"
 Cds CpuDet_25_Short, "SIMD "
 Cdse CpuDet_26, "SSE2 (WNI) Instructions"
 Cds CpuDet_26_Short, "SSe2 "
 Cdse CpuDet_27, "Self-Snoop"
 Cds CpuDet_27_Short, "SELFSNOOP "
 Cdse CpuDet_28, "Hyper-Threading Technology"
 Cds CpuDet_28_Short, "HTT "
 Cdse CpuDet_29, "Automatic Clock Control"
 Cds CpuDet_29_Short, "ACC "
 Cdse CpuDet_30, "IA64 Instructions?"
 Cds CpuDet_30_Short, "IA-64 "
 Cdse CpuDet_31, "Pending Break Event"
 Cds CpuDet_31_Short, "PBE "
 ; - Feature (CpuID 1/Edx) -
 ; - Stepping0-3/Model4-7/Family8-11/Type12-13/ExtModel16-19/20-27 (CpuID 1/Edx) -
 Crs CpuDet_SteppingIDString, "Cpu Stepping ID: "
  Cdse CpuDet_SteppingID, "  "
 Crs CpuDet_ModelString, "Cpu Model: "
  Cdse CpuDet_Model, "  "
 Crs CpuDet_FamilyString, "Cpu Family: "
  Cdse CpuDet_Family, "  "
 Crs CpuDet_TypeString, "Cpu Type: "
  Cdse CpuDet_Type, " "
 Crs CpuDet_ExtModelString, "Extended Cpu Model: "
  Cdse CpuDet_ExtModel, "  "
 Crs CpuDet_ExtFamilyString, "Extended Cpu Family: "
  Cdse CpuDet_ExtFamily, "   "
 ; - Stepping0-3/Model4-7/Family8-11/Type12-13/ExtModel16-19/20-27 (CpuID 1/Edx) -
 ; APIC ID/Logical Cpu ID/CFLUSH Chunk Size/BrandID (CpuId 1/Ebx)
 ;31..24 - default APIC ID
 ;23..16 - Logical processsor ID
 ;15..8 - CFLUSH chunk size 
 ;7..0 - brand ID - available from Pentium III up 
 ;Crs "CLFlush Chunk Count: "
 ; Cdse "      "
 ;Crs CpuCount, "Logical Processor Count: "
 ; Cdse "      "
 ;Crs CpuAPICID, "APIC ID: "
 ; Cdse "                    "
 ; - Level 2 CpuID 1 -

 ; - Level 3 CpuID 80000000 -
 ; - Get Extended CpuID Count (Eax)
 Crs CpuDet_ExtMaxArgString, "Extended CpuID Max Arguments: "
  Cdse CpuDet_ExtMaxArg, "             "
 ; - Get Extended CpuID Count (Eax)
 ; - Level 3 CpuID 80000000 -


 ; - Level 4 CpuID 80000001 -
 ; - Get Extended Feature Flags C (Ecx) -
 Cdse CpuDet_Ext1CFlags, " -=- Extended Flags -=-"
 Cds CpuDet_Ext1CFlags_Short, "Extended Flags: "
 ;31-5 Reserved
 Cdse CpuDet_Ext1C4, "MOV From/To CR8D using LOCK-Prefixed MOV From/To CR0"
 Cds CpuDet_Ext1C4_Short, "CR8D "
 Cdse CpuDet_Ext1C3, "Extended APIC Space (APIC_VER.EAS EXT_APIC_FEAT Ect.)"
 Cds CpuDet_Ext1C3_Short, "EAS "
 Cdse CpuDet_Ext1C2, "EFER.SVME VMRUN VMMCALL VMLOAD and VMSAVE STGI and CLGI SKINIT INVLPGA"
 Cds CpuDet_Ext1C2_Short, "SVM "
 Cdse CpuDet_Ext1C1, "HTT=1 Indicates HTT(0) Or CMP(1)"
 Cds CpuDet_Ext1C1_Short, "CMP "
 Cdse CpuDet_Ext1C0, "LAHF And SAHF In PM64"
 Cds CpuDet_Ext1C0_Short, "AHF64"
 ; - Get Extended Feature Flags C (Ecx) -
 ; - Get Extended Feature Flags D (Edx) -
 Cdse CpuDet_Ext1DFlags, " -=- Extended Flags -=-"
 Cds CpuDet_Ext1DFlags_Short, "Extended Flags: "
 Cdse CpuDet_Ext1D31, "3DNow!"
 Cds CpuDet_Ext1D31_Short, "3DNow! "
 Cdse CpuDet_Ext1D30, "Extended 3DNow!"
 Cds CpuDet_Ext1D30_Short, "3DNow!+ "
 Cdse CpuDet_Ext1D29, "AA-64 Long Mode"
 Cds CpuDet_Ext1D29_Short, "LM "
 ;28 Reserved
 Cdse CpuDet_Ext1D27, "TSC TSC_AUX RDTSCP CR4.TSD"
 Cds CpuDet_Ext1D27_Short, "TSCP "
 ;26 Reserved
 Cdse CpuDet_Ext1D25, "EFER.FFXSR"
 Cds CpuDet_Ext1D25_Short, "FFXSR "
 Cdse CpuDet_Ext1D24_Cyrix, "Extended MMX"
 Cds CpuDet_Ext1D24_Cyrix_Short, "MMX+ "
 Cdse CpuDet_Ext1D24_AMD_K7, "FXSAVE/FXRSTOR CR4.OSFXSR"
 Cds CpuDet_Ext1D24_AMD_K7_Short, "FXSR "
 Cdse CpuDet_Ext1D23, "MMX"
 Cds CpuDet_Ext1D23_Short, "MMX "
 Cdse CpuDet_Ext1D22, "MMX-SSE and SSE-MEM"
 Cds CpuDet_Ext1D22_Short, "MMX+ "
 ;21 Reserved
 Cdse CpuDet_Ext1D20, "EFER.NXE P?E.NX #PF(1xxxx)"
 Cds CpuDet_Ext1D20_Short, "NX "
 Cdse CpuDet_Ext1D19, "MP-Capable #3"
 Cds CpuDet_Ext1D19_Short, "MP "
 ;18 Reserved
 Cdse CpuDet_Ext1D17, "4 MB PDE Bits 16...13 CR4.PSE"
 Cds CpuDet_Ext1D17_Short, "PSE36 "
 Cdse CpuDet_Ext1D16, "FCMOVcc/F(U)COMI(P)"
 Cds CpuDet_Ext1D16_Short, "FCMOV "
 Cdse CpuDet_Ext1D16_AMD_K7, "PAT MSR PDE/PTE.PAT"
 Cds CpuDet_Ext1D16_AMD_K7_Short, "PAT "
 Cdse CpuDet_Ext1D15, "CMOVcc"
 Cds CpuDet_Ext1D15_Short, "CMOV "
 Cdse CpuDet_Ext1D14, "MCG_*/MCn_* MSRs CR4.MCE #MC"
 Cds CpuDet_Ext1D14_Short, "MCA "
 Cdse CpuDet_Ext1D13, "PDE/PTE.G CR4.PGE"
 Cds CpuDet_Ext1D13_Short, "PGE "
 Cdse CpuDet_Ext1D12, "MTRR* MSRs"
 Cds CpuDet_Ext1D12_Short, "MTRR "
 Cdse CpuDet_Ext1D11, "SYSCALL/SYSRET EFER/STAR MSRs #1"
 Cds CpuDet_Ext1D11_Short, "SEP "
 ;10 Reserved
 Cdse CpuDet_Ext1D9, "APIC #2"
 Cds CpuDet_Ext1D9_Short, "APIC "
 Cdse CpuDet_Ext1D8, "CMPXCHG8B"
 Cds CpuDet_Ext1D8_Short, "CX8 "
 Cdse CpuDet_Ext1D7, "MCAR/MCTR MSRs CR4.MCE #MC"
 Cds CpuDet_Ext1D7_Short, "MCE "
 Cdse CpuDet_Ext1D6, "64-Bit PDPTE/PDE/PTEs CR4.PAE"
 Cds CpuDet_Ext1D6_Short, "PAE "
 Cdse CpuDet_Ext1D5, "MSRs RDMSR/WRMSR"
 Cds CpuDet_Ext1D5_Short, "MSR "
 Cdse CpuDet_Ext1D4, "TSC RDTSC CR4.TSD"
 Cds CpuDet_Ext1D4_Short, "TSC "
 Cdse CpuDet_Ext1D3, "PDE.PS PDE/PTE.res CR4.PSE #PF(1xxxb)"
 Cds CpuDet_Ext1D3_Short, "PSE "
 Cdse CpuDet_Ext1D2, "CR4.DE DR7.RW=10b #UD On MOV From/To DR4/5"
 Cds CpuDet_Ext1D2_Short, "DE "
 Cdse CpuDet_Ext1D1, "CR4.VME/PVI EFLAGS.VIP/VIF TSS32.IRB"
 Cds CpuDet_Ext1D1_Short, "VME "
 Cdse CpuDet_Ext1D0, "FPU"
 Cds CpuDet_Ext1D0_Short, "FPU "
 ; - Get Extended Feature Flags D (Edx) -
 ; - Level 4 CpuID 80000001 -


 ; - Level 5 CpuID 80000002/3/4 -
 ; - Get Extended Cpu Name (Eax/Ebx/Ecx/Edx) -
 Crs CpuDet_ExtCpuNameString, "Extended CPU Name: "
  Crs CpuDet_ExtCpuName, "                                                "
 ; - Get Extended Cpu Name (Eax/Ebx/Ecx/Edx) -
 ; - Level 5 CpuID 80000002/3/4 -

EndData

Log_Print Macro String
 Local L_LogPrintError, L_LogPrintSizeError, L_LogPrintFinish
  GetStringLength16 String, "$", Log_BufferBytes
  Dos_WriteFile Log_Handle, Log_BufferBytes, String, Log_WrittenBytes, L_LogPrintError
  Move Ax, Log_BufferBytes
  CompareAndJumpIfNotEqual Ax, Log_WrittenBytes, L_LogPrintSizeError
  Dos_PrintString String
  Jump L_LogPrintFinish
 L_LogPrintError:
 L_LogPrintSizeError:
  Dos_Exit 1
 L_LogPrintFinish:
EndM

Log_SRAndPSIfSet Macro In,S0,S1,S2,S3,S4
  Local L0,L1,L2,L3,L4
  IfNb <S0>
   Push In
   ShiftRightAndJumpIfNotCarry In,L0
    Log_Print S0
   L0:
   Pop In
  EndIf
  IfNb <S1>
   Push In
   ShiftRightAndJumpIfNotCarry In,L1
    Log_Print S1
   L1:
   Pop In
  EndIf
  IfNb <S2>
   Push In
   ShiftRightAndJumpIfNotCarry In,L2
    Log_Print S2
   L2:
   Pop In
  EndIf
  IfNb <S3>
   Push In
   ShiftRightAndJumpIfNotCarry In,L3
    Log_Print S3
   L3:
   Pop In
  EndIf
  IfNb <S4>
   Push In
   ShiftRightAndJumpIfNotCarry In,L4
    Log_Print S4
   L4:
   Pop In
  EndIf
 EndM

; -=- Main Program -=-
StartProgram
 ; - Level 0 Log Start -
  Dos_DeleteFile Log_File, L_LogDeleteError
 L_LogCreate:
  Dos_CreateFile Log_File, Null, Log_Handle, L_LogCreateError
  Log_Print Log_Starting
 ; - Level 0 Log Start -


 Log_Print CpuDet_Start
 Call CpuDetect
 Log_Print CpuDet_End


 ; - Level 1 Log Finish -
  Log_Print Log_Finished
  Dos_CloseFile Log_Handle, L_LogCloseError
 ; - Level 1 Log Finish -


 Dos_Exit


 ; - Level 2 Log Errors -
 L_LogDeleteError:
  CompareAndJumpIfEqual Ax, 02h, L_LogCreate
 L_LogCloseError:
 L_LogCreateError:
  Dos_Exit 1
 ; - Level 2 Log Errors -


 CpuDetect Proc
  ; - Level 0 Scan -
  CpuDetect_8088:
    Move Cl, 20h, Ax, 1 ; 80186+ mask ShiftLeft, ShiftRight Count to 31 place.
    ShiftLogicalRight Ax, Cl
    JumpIfRegisterIsNotZero Ax, CpuDetect_80186
  CpuDetect_V20:
    MoveZero Al
    Push Cs
    DB 0Fh, 14H, 0C3h
    CompareAndJumpIfNotEqual Al, 0C3h, CpuDetect_IsV20
      Log_Print CpuDet_80888086
      Return
  CpuDetect_IsV20:
    Pop Ax
    Log_Print CpuDet_V20V30
    Return
  CpuDetect_80186:
    Move Bx, Sp
    Push Sp
    Pop Ax
    CompareAndJumpIfEqual Ax, Bx, CpuDetect_80286
      Log_Print CpuDet_80186
      Return
  CpuDetect_80286:
    ; Skipped
  CpuDetect_80386:
    Cli
    PushFD
    Pop Eax
    Move Ebx, Eax
    Xor Eax, 40000h
    Push Eax
    PopFD
    PushFD
    Pop Eax
    Push Ebx
    PopFD
    Sti
    Xor Eax, Ebx
    JumpIfNotZero CpuDetect_80486
      Log_Print CpuDet_80386
      Return
  CpuDetect_80486:
    Cli
    PushFD
    Pop Eax
    Move Ebx, Eax
    Xor Eax, 200000h
    Push Eax
    PopFD
    PushFD
    Pop Eax
    Push Ebx
    PopFD
    Sti
    Xor Eax, Ebx
    JumpIfNotZero CpuDetect_80586
      Log_Print CpuDet_80486
      Return
  CpuDetect_80586:
    Log_Print CpuDet_IdSupport
  ; - Level 0 Scan -


  ; - Level 1 CpuID 0 -
    MoveZero Eax
    CpuID
    Move CpuDet_Vendor1, Ebx
    Move CpuDet_Vendor2, Edx
    Move CpuDet_Vendor3, Ecx
    Move DWord Ptr [CpuDet_Vendor], Ebx
    Move DWord Ptr [CpuDet_Vendor+4], Edx
    Move DWord Ptr [CpuDet_Vendor+8], Ecx
    Move CpuDet_MaxArgVal, Eax
    Log_Print CpuDet_VendorString
    ConvertDWordToString32 CpuDet_MaxArgVal, CpuDet_MaxArg, UseDec
    Log_Print CpuDet_MaxArgString
    Move Eax, CpuDet_MaxArgVal
    JumpIfRegisterIsNotZero Eax, CpuDetect_NoReturn
      Return
    CpuDetect_NoReturn:
  ; - Level 1 CpuID 0 -


  ; - Level 2 CpuID 1 -
    Move Eax, 1
    CpuID
    Move CpuDet_TypeVal, Eax
    Move CpuDet_SerialNumber1, Eax
    Move CpuDet_BrandIDVal, Ebx
    Move CpuDet_Feature, Edx

    ; -=- Long Form -=-
    ;Log_Print CpuDet_Flags
    ;Move Ebx, Edx
    ;Log_SRAndPSIfSet Ebx, CpuDet_0, CpuDet_1, CpuDet_2, CpuDet_3
    ;Log_SRAndPSIfSet Ebx, CpuDet_4, CpuDet_5, CpuDet_6_Intel, CpuDet_7
    ;Log_SRAndPSIfSet Ebx, CpuDet_8, CpuDet_9_Intel
    ;ShiftRight1 Ebx
    ;Log_SRAndPSIfSet Ebx, CpuDet_11, CpuDet_12, CpuDet_13, CpuDet_14
    ;Log_SRAndPSIfSet Ebx, CpuDet_15, CpuDet_16, CpuDet_17, CpuDet_18
    ;Log_SRAndPSIfSet Ebx, CpuDet_19
    ;ShiftRight1 Ebx
    ;Log_SRAndPSIfSet Ebx, CpuDet_21, CpuDet_22, CpuDet_23, CpuDet_24
    ;Log_SRAndPSIfSet Ebx, CpuDet_25, CpuDet_26, CpuDet_27, CpuDet_28
    ;Log_SRAndPSIfSet Ebx, CpuDet_29, CpuDet_30, CpuDet_31
    ; -=- Short Form -=-
    Log_Print CpuDet_Flags_Short
    Move Ebx, Edx
    Log_SRAndPSIfSet Ebx, CpuDet_0_Short, CpuDet_1_Short, CpuDet_2_Short, CpuDet_3_Short
    Log_SRAndPSIfSet Ebx, CpuDet_4_Short, CpuDet_5_Short, CpuDet_6_Intel_Short, CpuDet_7_Short
    Log_SRAndPSIfSet Ebx, CpuDet_8_Short, CpuDet_9_Intel_Short
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, CpuDet_11_Short, CpuDet_12_Short, CpuDet_13_Short, CpuDet_14_Short
    Log_SRAndPSIfSet Ebx, CpuDet_15_Short, CpuDet_16_Short, CpuDet_17_Short, CpuDet_18_Short
    Log_SRAndPSIfSet Ebx, CpuDet_19_Short
    ShiftRight1 Ebx
    Log_SRAndPSIfSet Ebx, CpuDet_21_Short, CpuDet_22_Short, CpuDet_23_Short, CpuDet_24_Short
    Log_SRAndPSIfSet Ebx, CpuDet_25_Short, CpuDet_26_Short, CpuDet_27_Short, CpuDet_28_Short
    Log_SRAndPSIfSet Ebx, CpuDet_29_Short, CpuDet_30_Short, CpuDet_31_Short
    Log_Print String_Cr

    Move Eax, CpuDet_TypeVal
    And Al, 1111b
    Move Temp8, Al
    ConvertByteToString Temp8, CpuDet_SteppingID, UseDec
    Log_Print CpuDet_SteppingIDString

    Move Eax, CpuDet_TypeVal
    ShiftRight4 Al
    And Al, 1111b
    Move Temp8, Al
    ConvertByteToString Temp8, CpuDet_Model, UseDec
    Log_Print CpuDet_ModelString

    Move Eax, CpuDet_TypeVal
    And Ah, 1111b
    Move Temp8, Ah
    ConvertByteToString Temp8, CpuDet_Family, UseDec
    Log_Print CpuDet_FamilyString

    Move Eax, CpuDet_TypeVal
    ShiftRight4 Ah
    And Ah, 1111b
    Move Temp8, Ah
    ConvertByteToString Temp8, CpuDet_Type, UseDec
    Log_Print CpuDet_TypeString

    Move Eax, CpuDet_TypeVal
    SwapWord32 Eax
    And Al, 1111b
    Move Temp8, Al
    ConvertByteToString Temp8, CpuDet_ExtModel, UseDec
    Log_Print CpuDet_ExtModelString

    Move Eax, CpuDet_TypeVal
    SwapWord32 Eax
    ShiftLeft4 Eax
    Move Temp8, Al
    ConvertByteToString Temp8, CpuDet_ExtFamily, UseDec
    Log_Print CpuDet_ExtFamilyString
  ;EBX = 31..24 - default APIC ID
  ; 23..16 - Logical processsor ID
  ; 15..8 - CFLUSH chunk size 
  ; 7..0 - brand ID - available from Pentium III up 
  ; - Level 2 CpuID 1 -

  ; - Level 3 ExtCpuID 80000000 -
  Move Eax, 80000000h
  CpuID
  And Eax, 01111111111111111111111111111111b
  Move CpuDet_ExtMaxArgVal, Eax
  ConvertDWordToString32 CpuDet_ExtMaxArgVal, CpuDet_ExtMaxArg, UseDec
  Log_Print CpuDet_ExtMaxArgString
  ; - Level 3 ExtCpuID 80000000 -


  ; - Level 4 ExtCpuID 80000001 -
  Move Eax, 80000001h
  CpuID
  Move CpuDet_Ext1DFeatureFlags, Edx
  Move CpuDet_Ext1CFeatureFlags, Ecx

  ;Log_Print CpuDet_Ext1DFlags
  ;Move Eax, 80000001h
  ;CpuID
  ;Move Ebx, Edx
  ;Move CpuDet_Ext1DFeatureFlags, Edx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D0, CpuDet_Ext1D1, CpuDet_Ext1D2, CpuDet_Ext1D3
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D4, CpuDet_Ext1D5, CpuDet_Ext1D6, CpuDet_Ext1D7
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D8, CpuDet_Ext1D9
  ;ShiftRight1 Ebx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D11, CpuDet_Ext1D12, CpuDet_Ext1D13, CpuDet_Ext1D14
  ;; AMD K-7 Deviant on Bit16
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D15, CpuDet_Ext1D16, CpuDet_Ext1D17
  ;ShiftRight1 Ebx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D19, CpuDet_Ext1D20
  ;ShiftRight1 Ebx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D22, CpuDet_Ext1D23
  ;; AMD/Cyrix Deviant on Bit 24
  ;ShiftRight1 Ebx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D25
  ;ShiftRight1 Ebx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D27
  ;ShiftRight1 Ebx
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1D29, CpuDet_Ext1D30, CpuDet_Ext1D31
  ;Log_Print CpuDet_Ext1DFlags
  Log_Print CpuDet_Ext1DFlags_Short
  Move Ebx, CpuDet_Ext1DFeatureFlags
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D0_Short, CpuDet_Ext1D1_Short, CpuDet_Ext1D2_Short, CpuDet_Ext1D3_Short
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D4_Short, CpuDet_Ext1D5_Short, CpuDet_Ext1D6_Short, CpuDet_Ext1D7_Short
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D8_Short, CpuDet_Ext1D9_Short
  ShiftRight1 Ebx
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D11_Short, CpuDet_Ext1D12_Short, CpuDet_Ext1D13_Short, CpuDet_Ext1D14_Short
  ; AMD K-7 Deviant on Bit16
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D15_Short, CpuDet_Ext1D16_Short, CpuDet_Ext1D17_Short
  ShiftRight1 Ebx
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D19_Short, CpuDet_Ext1D20_Short
  ShiftRight1 Ebx
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D22_Short, CpuDet_Ext1D23_Short
  ; AMD/Cyrix Deviant on Bit 24
  ShiftRight1 Ebx
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D25_Short
  ShiftRight1 Ebx
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D27_Short
  ShiftRight1 Ebx
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1D29_Short, CpuDet_Ext1D30_Short, CpuDet_Ext1D31_Short
  Log_Print String_Cr


  ;Log_Print CpuDet_Ext1DFlags
  ;Move Ebx, CpuDet_Ext1CFeatureFlags
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1C0, CpuDet_Ext1C1, CpuDet_Ext1C2, CpuDet_Ext1C3
  ;Log_SRAndPSIfSet Ebx, CpuDet_Ext1C4
  Log_Print CpuDet_Ext1DFlags_Short
  Move Ebx, CpuDet_Ext1CFeatureFlags
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1C0_Short, CpuDet_Ext1C1_Short, CpuDet_Ext1C2_Short, CpuDet_Ext1C3_Short
  Log_SRAndPSIfSet Ebx, CpuDet_Ext1C4_Short
  Log_Print String_Cr
  ; - Level 4 ExtCpuID 80000001 -


  ; - Level 5 ExtCpuID 80000002/3/4 -
  Move Eax, 80000002h
  CpuID
  Move CpuDet_ExtCpuName1, Eax
  Move CpuDet_ExtCpuName2, Ebx
  Move CpuDet_ExtCpuName3, Ecx
  Move CpuDet_ExtCpuName4, Edx
  Move DWord Ptr [CpuDet_ExtCpuName], Eax
  Move DWord Ptr [CpuDet_ExtCpuName+4], Ebx
  Move DWord Ptr [CpuDet_ExtCpuName+8], Ecx
  Move DWord Ptr [CpuDet_ExtCpuName+12], Edx
  Move Eax, 80000003h
  CpuID
  Move CpuDet_ExtCpuName5, Eax
  Move CpuDet_ExtCpuName6, Ebx
  Move CpuDet_ExtCpuName7, Ecx
  Move CpuDet_ExtCpuName8, Edx
  Move DWord Ptr [CpuDet_ExtCpuName+16], Eax
  Move DWord Ptr [CpuDet_ExtCpuName+20], Ebx
  Move DWord Ptr [CpuDet_ExtCpuName+24], Ecx
  Move DWord Ptr [CpuDet_ExtCpuName+28], Edx
  Move Eax, 80000004h
  CpuID
  Move CpuDet_ExtCpuName9, Eax
  Move CpuDet_ExtCpuName10, Ebx
  Move CpuDet_ExtCpuName11, Ecx
  Move CpuDet_ExtCpuName12, Edx
  Move DWord Ptr [CpuDet_ExtCpuName+32], Eax
  Move DWord Ptr [CpuDet_ExtCpuName+36], Ebx
  Move DWord Ptr [CpuDet_ExtCpuName+40], Ecx
  Move DWord Ptr [CpuDet_ExtCpuName+44], Edx
  ConvertStringToString16WithCrLf CpuDet_ExtCpuName, 0, "$"
  Log_Print CpuDet_ExtCpuNameString  
  ; - Level 5 ExtCpuID 80000002/3/4 -

  Return
CpuDetect EndP


; -=- End of Program -=-
EndProgram

 ;Cie 3, Cpu_Cyrix, Cpu_Centar, Cpu_SiS
 ;Cie 6, Cpu_NexGen, Cpu_Transmeta, Cpu_Rise, Cpu_UMC, Cpu_NSC
 ;Cie 11, Cpu_AMDK5
 ;Crs CpuDet_Cyrix, "CyrixInstead"
 ;Crs CpuDet_Centar, "CentaurHauls"
 ;Crs CpuDet_NexGen, "NexGenDrive"
 ;Crs CpuDet_Rise, "RiseRiseRise"
 ;Crs CpuDet_UMC, "UMC UMC UMC "
 ;Crs CpuDet_SiS, ""
 ;Crs CpuDet_Transmeta, ""
 ;Crs CpuDet_NSC, ""
 ;Crs CpuDet_AMDK5, ""

;AMD - Standard (Family-Model-ExtFamily?,Name)
;4-3-x,486 DX/2
;4-7-x,486 DX/2-WB
;4-8-x,486 DX/4
;4-9-x,486 DX/4-WB
;4-14-x,Am5x86-WT
;4-15-x,Am5x86-WB
;5-0-x,K5/SSA5
;5-1/2/3-5,K5
;5-6/7-6,K6
;5-8-6,K6-2
;5-9-6,K6-3
;4-13-6,K6-2+/K6-III+
;6-0/1-7,Athlon (25 m)
;6-2-7,Athlon (18 m)
;6-3-7,Duron
;6-4-7,Athlon (Thunderbird)
;6-6-7,Athlon (Palamino)
;6-7-7,Duron (Morgan)
;6-8-7,Athlon (Thoroughbred)
;6-10-7,Athlon (Barton)
;15-x-x,Extended

;AMD - Extended (ExtFamily-Model,Name)
;0-4,Athlon 64
;0-5,Athlon 64 FX Opteron

;Intel - Standard (Family-Mode,Name)
;4-0,486 DX-25/33
;4-1,486 DX-50
;4-2,486 SX
;4-3,486 DX/2
;4-4,486 SL
;4-5,486 SX/2
;4-7,486 DX/2-WB
;4-8,486 DX/4
;4-9,486 DX/4-WB
;5-0,Pentium 60/66 A-step
;5-1,Pentium 60/66
;5-2,Pentium 75 - 200
;5-3,OverDrive PODP5V83
;5-4,Pentium MMX
;5-7,Mobile Pentium 75 - 200
;5-8,Mobile Pentium MMX
;6-0,Pentium Pro A-step
;6-1,Pentium Pro
;6-3,Pentium II (Klamath)
;6-5,Pentium II (Deschutes)/Celeron (Covington)/Mobile Pentium II (Dixon)
;6-6,Mobile Pentium II/Celeron (Mendocino)
;6-7,Pentium III (Katmai)
;6-8,Pentium III (Coppermine)
;6-9,Mobile Pentium III
;6-10,Pentium III (0.18 m)
;6-11,Pentium III (0.13 m)
;7-x,Itanium (IA-64)
;15-x,Extended

;Intel Extended (ExtFamily-Model,Name)
;0-0/1,Pentium IV (0.18 m)
;0-2,Pentium IV (0.13 m)
;0-3,Pentium IV (0.09 m)
;1-x,Itanium 2 (IA-64)

;Cyrix Standard (Family-Model,Name)
;4-4,MediaGX
;5-2,6x86/6x86L
;5-4,MediaGX MMX Enhanced
;6-0,m II (6x86MX)
;6-5,VIA Cyrix M2 core
;6-6,WinChip C5A
;6-7,WinChip C5B/WinChip C5C
;6-8,WinChip C5N
;6-9,WinChip C5XL/WinChip C5P
;UMC Standard (Family-Model,Name)
;4-1,U5D
;4-2,U5S
;NexGen Standard (Family-Model,Name)
;5-0,Nx586
;Rise Standard (Family-Model,Name)
;5-0/1,mP6
;SiS Standard (Family-Model,Name)
;5-0,55x
;Transmeta Standard (Family-Model,Name)
;5-4,Crusoe TM3x00/Crusoe TM5x00
;Centaur Standard (Family-Model,Name)
;5-4,C6
;5-8,C2
;5-9,C3
;National Semiconductor CPU signatures Family Model Name
;5-4,GX1/GXLV/GXm
;5-5,GX2









extended level 8000_0005h
 
input 	EAX=8000_0005h 	get L1 cache and TLB configuration descriptors #1
output 	EAX 	4/2 MB L1 TLB configuration descriptor
bits 	description
31...24 	data TLB associativity (FFh=full)
23...16 	data TLB entries
15...8 	code TLB associativity (FFh=full)
7...0 	code TLB entries
EBX 	4 KB L1 TLB configuration descriptor #2
bits 	description
31...24 	data TLB associativity (FFh=full)
23...16 	data TLB entries
15...8 	code TLB associativity (FFh=full)
7...0 	code TLB entries
ECX 	data L1 cache configuration descriptor
bits 	description
31...24 	data L1 cache size in KBs
23...16 	data L1 cache associativity (FFh=full)
15...8 	data L1 cache lines per tag
7...0 	data L1 cache line size in bytes
EDX 	code L1 cache configuration descriptor
bits 	description
31...24 	code L1 cache size in KBs
23...16 	code L1 cache associativity (FFh=full)
15...8 	code L1 cache lines per tag
7...0 	code L1 cache line size in bytes
notes 	description
#1 	Cyrix processors return CPUID level 0000_0002h-like descriptors instead. (Though the NS Geode GX2 does not.)
#2 	While Transmeta Crusoe processors have 256 entries, the CPUID definition constrains them to reporting only 255.
For compatibility reasons they report their unified TLB twice: once for the code TLB, and once for the data TLB.

 
extended level 8000_0006h
 
input 	EAX=8000_0006h 	get L2 cache configuration descriptors
output 	EAX 	4/2 MB L2 TLB configuration descriptor #1
bits 	description
31...28 	data TLB associativity #2
27...16 	data TLB entries
15...12 	code TLB associativity #2
11...0 	code TLB entries
EBX 	4 KB L2 TLB configuration descriptor #1
bits 	description
31...28 	data TLB associativity #2
27...16 	data TLB entries
15...12 	code TLB associativity #2
11...0 	code TLB entries
ECX 	unified L2 cache configuration descriptor #3
bits 	description
31...16 #5 	unified L2 cache size in KBs #4
15...12 #5 	unified L2 cache associativity #2, #6
11...8 #5 	unified L2 cache lines per tag
7...0 	unified L2 cache line size in bytes
note 	description
#1 	A unified L2 TLB is indicated by a value of 0000h in the upper 16 bits.
#2 	0000b=L2 off, 0001b=direct mapped, 0010b=2-way, 0100b=4-way, 0110b=8-way, 1000b=16-way, 1111b=full
#3 	The AMD K7 processor's L2 cache must be configured prior to relying upon this information, if the model is 1 or 2.
#4 	AMD K7 processors with CPUID=0630h (Duron) inadvertently report 1 KB instead of 64 KB.
#5 	VIA C3 processors with CPUID=0670...068Fh (C5B/C5C) inadvertently use bits 31...24, 23...16, and 15...8 instead.
#6 	VIA C3 processors with CPUID=069x (C5XL) and stepping 1 inadvertently report 0 ways instead of 16 ways.